/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ProjectInvitationDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProjectInvitationDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProjectInvitationForProjectManipulationDto } from '../../@coscine/model';
/**
 * ProjectInvitationApi - axios parameter creator
 * @export
 */
export const ProjectInvitationApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdInvitationsOptions: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdInvitationsOptions', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/invitations`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Creates a project invitation for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {ProjectInvitationForProjectManipulationDto} [projectInvitationForProjectManipulationDto] The project invitation data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createProjectInvitation: async (projectId: string, projectInvitationForProjectManipulationDto?: ProjectInvitationForProjectManipulationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('createProjectInvitation', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/invitations`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectInvitationForProjectManipulationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a project invitation for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} projectInvitationId The ID of the project invitation to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteProjectInvitation: async (projectId: string, projectInvitationId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('deleteProjectInvitation', 'projectId', projectId)
            // verify required parameter 'projectInvitationId' is not null or undefined
            assertParamExists('deleteProjectInvitation', 'projectInvitationId', projectInvitationId)
            const localVarPath = `/api/v2/projects/{projectId}/invitations/{projectInvitationId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"projectInvitationId"}}`, encodeURIComponent(String(projectInvitationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a project invitation for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} projectInvitationId The ID of the project invitation to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectInvitation: async (projectId: string, projectInvitationId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getProjectInvitation', 'projectId', projectId)
            // verify required parameter 'projectInvitationId' is not null or undefined
            assertParamExists('getProjectInvitation', 'projectInvitationId', projectInvitationId)
            const localVarPath = `/api/v2/projects/{projectId}/invitations/{projectInvitationId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"projectInvitationId"}}`, encodeURIComponent(String(projectInvitationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all project invitations for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectInvitations: async (projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getProjectInvitations', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/invitations`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectInvitationApi - functional programming interface
 * @export
 */
export const ProjectInvitationApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectInvitationApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdInvitationsOptions(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdInvitationsOptions(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectInvitationApi.apiV2ProjectsProjectIdInvitationsOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Creates a project invitation for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {ProjectInvitationForProjectManipulationDto} [projectInvitationForProjectManipulationDto] The project invitation data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createProjectInvitation(projectId: string, projectInvitationForProjectManipulationDto?: ProjectInvitationForProjectManipulationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectInvitationDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createProjectInvitation(projectId, projectInvitationForProjectManipulationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectInvitationApi.createProjectInvitation']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Deletes a project invitation for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} projectInvitationId The ID of the project invitation to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteProjectInvitation(projectId: string, projectInvitationId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteProjectInvitation(projectId, projectInvitationId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectInvitationApi.deleteProjectInvitation']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a project invitation for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} projectInvitationId The ID of the project invitation to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getProjectInvitation(projectId: string, projectInvitationId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectInvitationDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getProjectInvitation(projectId, projectInvitationId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectInvitationApi.getProjectInvitation']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all project invitations for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getProjectInvitations(projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectInvitationDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getProjectInvitations(projectId, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectInvitationApi.getProjectInvitations']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectInvitationApi - factory interface
 * @export
 */
export const ProjectInvitationApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectInvitationApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdInvitationsOptions(requestParameters: ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdInvitationsOptions(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Creates a project invitation for a specified project.
         * @param {ProjectInvitationApiCreateProjectInvitationRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createProjectInvitation(requestParameters: ProjectInvitationApiCreateProjectInvitationRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectInvitationDtoResponse> {
            return localVarFp.createProjectInvitation(requestParameters.projectId, requestParameters.projectInvitationForProjectManipulationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a project invitation for a specified project.
         * @param {ProjectInvitationApiDeleteProjectInvitationRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteProjectInvitation(requestParameters: ProjectInvitationApiDeleteProjectInvitationRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.deleteProjectInvitation(requestParameters.projectId, requestParameters.projectInvitationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a project invitation for a specified project.
         * @param {ProjectInvitationApiGetProjectInvitationRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectInvitation(requestParameters: ProjectInvitationApiGetProjectInvitationRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectInvitationDtoResponse> {
            return localVarFp.getProjectInvitation(requestParameters.projectId, requestParameters.projectInvitationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all project invitations for a specified project.
         * @param {ProjectInvitationApiGetProjectInvitationsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getProjectInvitations(requestParameters: ProjectInvitationApiGetProjectInvitationsRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectInvitationDtoPagedResponse> {
            return localVarFp.getProjectInvitations(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdInvitationsOptions operation in ProjectInvitationApi.
 * @export
 * @interface ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptionsRequest
 */
export interface ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptions
     */
    readonly projectId: string
}

/**
 * Request parameters for createProjectInvitation operation in ProjectInvitationApi.
 * @export
 * @interface ProjectInvitationApiCreateProjectInvitationRequest
 */
export interface ProjectInvitationApiCreateProjectInvitationRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectInvitationApiCreateProjectInvitation
     */
    readonly projectId: string

    /**
     * The project invitation data for creation.
     * @type {ProjectInvitationForProjectManipulationDto}
     * @memberof ProjectInvitationApiCreateProjectInvitation
     */
    readonly projectInvitationForProjectManipulationDto?: ProjectInvitationForProjectManipulationDto
}

/**
 * Request parameters for deleteProjectInvitation operation in ProjectInvitationApi.
 * @export
 * @interface ProjectInvitationApiDeleteProjectInvitationRequest
 */
export interface ProjectInvitationApiDeleteProjectInvitationRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectInvitationApiDeleteProjectInvitation
     */
    readonly projectId: string

    /**
     * The ID of the project invitation to delete.
     * @type {string}
     * @memberof ProjectInvitationApiDeleteProjectInvitation
     */
    readonly projectInvitationId: string
}

/**
 * Request parameters for getProjectInvitation operation in ProjectInvitationApi.
 * @export
 * @interface ProjectInvitationApiGetProjectInvitationRequest
 */
export interface ProjectInvitationApiGetProjectInvitationRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectInvitationApiGetProjectInvitation
     */
    readonly projectId: string

    /**
     * The ID of the project invitation to retrieve.
     * @type {string}
     * @memberof ProjectInvitationApiGetProjectInvitation
     */
    readonly projectInvitationId: string
}

/**
 * Request parameters for getProjectInvitations operation in ProjectInvitationApi.
 * @export
 * @interface ProjectInvitationApiGetProjectInvitationsRequest
 */
export interface ProjectInvitationApiGetProjectInvitationsRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectInvitationApiGetProjectInvitations
     */
    readonly projectId: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof ProjectInvitationApiGetProjectInvitations
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof ProjectInvitationApiGetProjectInvitations
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof ProjectInvitationApiGetProjectInvitations
     */
    readonly orderBy?: string
}

/**
 * ProjectInvitationApi - object-oriented interface
 * @export
 * @class ProjectInvitationApi
 * @extends {BaseAPI}
 */
export class ProjectInvitationApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectInvitationApi
     */
    public apiV2ProjectsProjectIdInvitationsOptions(requestParameters: ProjectInvitationApiApiV2ProjectsProjectIdInvitationsOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectInvitationApiFp(this.configuration).apiV2ProjectsProjectIdInvitationsOptions(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Creates a project invitation for a specified project.
     * @param {ProjectInvitationApiCreateProjectInvitationRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectInvitationApi
     */
    public createProjectInvitation(requestParameters: ProjectInvitationApiCreateProjectInvitationRequest, options?: RawAxiosRequestConfig) {
        return ProjectInvitationApiFp(this.configuration).createProjectInvitation(requestParameters.projectId, requestParameters.projectInvitationForProjectManipulationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Deletes a project invitation for a specified project.
     * @param {ProjectInvitationApiDeleteProjectInvitationRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectInvitationApi
     */
    public deleteProjectInvitation(requestParameters: ProjectInvitationApiDeleteProjectInvitationRequest, options?: RawAxiosRequestConfig) {
        return ProjectInvitationApiFp(this.configuration).deleteProjectInvitation(requestParameters.projectId, requestParameters.projectInvitationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a project invitation for a specified project.
     * @param {ProjectInvitationApiGetProjectInvitationRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectInvitationApi
     */
    public getProjectInvitation(requestParameters: ProjectInvitationApiGetProjectInvitationRequest, options?: RawAxiosRequestConfig) {
        return ProjectInvitationApiFp(this.configuration).getProjectInvitation(requestParameters.projectId, requestParameters.projectInvitationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all project invitations for a specified project.
     * @param {ProjectInvitationApiGetProjectInvitationsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectInvitationApi
     */
    public getProjectInvitations(requestParameters: ProjectInvitationApiGetProjectInvitationsRequest, options?: RawAxiosRequestConfig) {
        return ProjectInvitationApiFp(this.configuration).getProjectInvitations(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }
}

